package com.xmomen.module.user.entity;

import com.xmomen.framework.mybatis.model.BaseMybatisExample;

import java.util.ArrayList;
import java.util.List;

// 定义一个SysRolesPermissionsExample类，继承自BaseMybatisExample类
public class SysRolesPermissionsExample extends BaseMybatisExample {
    // 定义一个orderByClause变量，用于存储排序字段
    protected String orderByClause;

    // 定义一个distinct变量，用于存储是否去重
    protected boolean distinct;

    // 定义一个oredCriteria变量，用于存储查询条件
    protected List<Criteria> oredCriteria;

    // 构造函数，初始化oredCriteria变量
    public SysRolesPermissionsExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    // 设置orderByClause变量的值
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    // 获取orderByClause变量的值
    public String getOrderByClause() {
        return orderByClause;
    }

    // 设置distinct变量的值
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    // 获取distinct变量的值
    public boolean isDistinct() {
        return distinct;
    }

    // 获取oredCriteria变量的值
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    // 添加一个查询条件
    public void or(Criteria criteria) {
    // 返回一个新的Criteria对象，并将其添加到oredCriteria列表中
        oredCriteria.add(criteria);
    }
    // 创建一个新的查询条件

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
        // 调用createCriteriaInternal()方法创建一个Criteria对象
    // 创建一个新的查询条件
        // 如果oredCriteria集合为空，则将创建的Criteria对象添加到oredCriteria集合中
    // 创建一个Criteria对象
    }
        // 返回创建的Criteria对象

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
    // 创建一个新的查询条件
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    // 清空oredCriteria变量和orderByClause变量和distinct变量的值
    protected Criteria createCriteriaInternal() {
    // 清空查询条件
        // 清空oredCriteria中的所有条件
        Criteria criteria = new Criteria();
        // 将orderByClause置为null
        return criteria;
    // 定义一个GeneratedCriteria内部类，用于存储查询条件
        // 将distinct置为false
        // 定义一个criteria变量，用于存储查询条件
    }

        // 构造函数，初始化criteria变量
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }
        // 判断是否有查询条件

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        // 获取所有的查询条件
        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }
        // 获取查询条件

        public boolean isValid() {
        // 获取所有标准
            return criteria.size() > 0;
        // 添加一个查询条件
        }

        // 获取标准
        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        // 添加一个查询条件
        // 添加标准
        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
        // 添加一个查询条件
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
        // 判断ID是否为空
                throw new RuntimeException("Value for " + property + " cannot be null");
            // 判断value1和value2是否为空，如果为空则抛出异常
            }
            // 将条件、value1和value2添加到criteria中
            criteria.add(new Criterion(condition, value));
        // 判断ID是否不为空
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
        // 判断ID是否等于某个值
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
        // 判断ID是否不等于某个值
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
        // 判断ID是否大于某个值
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Integer value) {
        // 判断ID是否大于等于某个值
            // 返回当前Criteria对象
            // 添加条件，ID不等于value
            addCriterion("ID =", value, "id");
        // 添加条件，ID大于value
            // 添加条件，ID大于value
        // 判断ID是否小于某个值
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Integer value) {
            addCriterion("ID <>", value, "id");
        // 判断ID是否小于等于某个值
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Integer value) {
            addCriterion("ID >", value, "id");
        // 判断ID是否在某个范围内
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ID >=", value, "id");
        // 判断ID是否不在某个范围内
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Integer value) {
            addCriterion("ID <", value, "id");
        // 判断ID是否在某个范围内
            return (Criteria) this;
        }

            // 添加条件，ID在values中
            // 返回当前Criteria对象
        // 判断ID是否不在某个范围内
        public Criteria andIdLessThanOrEqualTo(Integer value) {
        // 添加条件，ID不在values中
            addCriterion("ID <=", value, "id");
            // 添加条件，ID不在values中
            return (Criteria) this;
        // 判断roleId是否为空
            // 返回当前Criteria对象
        }

        public Criteria andIdIn(List<Integer> values) {
            addCriterion("ID in", values, "id");
        // 判断roleId是否不为空
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Integer> values) {
            addCriterion("ID not in", values, "id");
        // 判断roleId是否等于某个值
            return (Criteria) this;
        }

        public Criteria andIdBetween(Integer value1, Integer value2) {
            addCriterion("ID between", value1, value2, "id");
        // 判断roleId是否不等于某个值
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ID not between", value1, value2, "id");
        // 判断roleId是否大于某个值
            return (Criteria) this;
        }

        public Criteria andRoleIdIsNull() {
            addCriterion("ROLE_ID is null");
        // 判断roleId是否大于等于某个值
            return (Criteria) this;
        // 根据角色ID等于指定值添加查询条件
        }

        public Criteria andRoleIdIsNotNull() {
        // 判断roleId是否小于某个值
            addCriterion("ROLE_ID is not null");
        // 根据角色ID不等于指定值添加查询条件
            return (Criteria) this;
        }

        // 判断roleId是否小于等于某个值
        public Criteria andRoleIdEqualTo(Integer value) {
            addCriterion("ROLE_ID =", value, "roleId");
            return (Criteria) this;
        }

        // 判断roleId是否在某个范围内
        public Criteria andRoleIdNotEqualTo(Integer value) {
            addCriterion("ROLE_ID <>", value, "roleId");
            return (Criteria) this;
        }

        // 判断roleId是否不在某个范围内
        public Criteria andRoleIdGreaterThan(Integer value) {
            addCriterion("ROLE_ID >", value, "roleId");
            return (Criteria) this;
        }

        // 判断roleId是否在某个范围内
        // 添加一个条件，要求ROLE_ID大于等于value
        public Criteria andRoleIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("ROLE_ID >=", value, "roleId");
            return (Criteria) this;
        }

        // 判断roleId是否不在某个范围内
        public Criteria andRoleIdLessThan(Integer value) {
            addCriterion("ROLE_ID <", value, "roleId");
            return (Criteria) this;
        }

        // 判断permissionId是否为空
        public Criteria andRoleIdLessThanOrEqualTo(Integer value) {
            addCriterion("ROLE_ID <=", value, "roleId");
            return (Criteria) this;
        }

        // 判断permissionId是否不为空
        public Criteria andRoleIdIn(List<Integer> values) {
            addCriterion("ROLE_ID in", values, "roleId");
            return (Criteria) this;
        }

        // 判断permissionId是否等于某个值
        addCriterion("ROLE_ID not in", values, "roleId");
    }

    public Criteria andRoleIdBetween(Integer value1, Integer value2) {
        // 添加条件，ROLE_ID的值在value1和value2之间
        addCriterion("ROLE_ID between", value1, value2, "roleId");
        // 判断permissionId是否不等于某个值
        return (Criteria) this;
        return (Criteria) this;
        public Criteria andRoleIdNotIn(List<Integer> values) {
        // 添加条件，ROLE_ID的值在value1和value2之间
        }
        // 判断permissionId是否大于某个值

        public Criteria andRoleIdNotBetween(Integer value1, Integer value2) {
            addCriterion("ROLE_ID not between", value1, value2, "roleId");
        // 添加条件，PERMISSION_ID的值为空
            return (Criteria) this;
        // 判断permissionId是否大于等于某个值
        }

        public Criteria andPermissionIdIsNull() {
        // 添加条件，PERMISSION_ID的值不为空
            addCriterion("PERMISSION_ID is null");
        // 判断permissionId是否小于某个值
            return (Criteria) this;
        }

        public Criteria andPermissionIdIsNotNull() {
            addCriterion("PERMISSION_ID is not null");
        // 判断permissionId是否小于等于某个值
            return (Criteria) this;
        }

        public Criteria andPermissionIdEqualTo(Integer value) {
            addCriterion("PERMISSION_ID =", value, "permissionId");
        // 判断permissionId是否在某个范围内
            return (Criteria) this;
        }

        public Criteria andPermissionIdNotEqualTo(Integer value) {
            addCriterion("PERMISSION_ID <>", value, "permissionId");
        // 判断permissionId是否不在某个范围内
            return (Criteria) this;
        }

        public Criteria andPermissionIdGreaterThan(Integer value) {
            addCriterion("PERMISSION_ID >", value, "permissionId");
        // 判断permissionId是否在某个范围内
            return (Criteria) this;
        }

        public Criteria andPermissionIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("PERMISSION_ID >=", value, "permissionId");
        // 判断permissionId是否不在某个范围内
            return (Criteria) this;
        }

        // 添加条件，PERMISSION_ID小于value
        public Criteria andPermissionIdLessThan(Integer value) {
            addCriterion("PERMISSION_ID <", value, "permissionId");
            return (Criteria) this;
    // 定义一个Criteria内部类，继承自GeneratedCriteria类
        }

        public Criteria andPermissionIdLessThanOrEqualTo(Integer value) {
            addCriterion("PERMISSION_ID <=", value, "permissionId");
        // 根据权限ID列表添加条件
            return (Criteria) this;
        }
    // 定义一个Criterion内部类，用于存储查询条件

        public Criteria andPermissionIdIn(List<Integer> values) {
            addCriterion("PERMISSION_ID in", values, "permissionId");
            return (Criteria) this;
        }

        public Criteria andPermissionIdNotIn(List<Integer> values) {
            addCriterion("PERMISSION_ID not in", values, "permissionId");
            return (Criteria) this;
        }

        // 添加条件，PERMISSION_ID在value1和value2之间
        public Criteria andPermissionIdBetween(Integer value1, Integer value2) {
            addCriterion("PERMISSION_ID between", value1, value2, "permissionId");
            return (Criteria) this;
        }

        // 添加条件，PERMISSION_ID不在value1和value2之间
        public Criteria andPermissionIdNotBetween(Integer value1, Integer value2) {
        // 获取condition变量的值
            addCriterion("PERMISSION_ID not between", value1, value2, "permissionId");
            return (Criteria) this;
        }
    }
        // 获取value变量的值

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
        // 获取secondValue变量的值
            super();
        }
    }

        // 判断是否有值
    public static class Criterion {
        private String condition;

        private Object value;
        // 判断是否只有一个值

        private Object secondValue;

        private boolean noValue;
        // 判断是否在某个范围内

        private boolean singleValue;

        private boolean betweenValue;
        // 判断是否在某个范围内

        private boolean listValue;

        private String typeHandler;
        // 获取typeHandler变量的值
        // 获取条件

        public String getCondition() {
            return condition;
        // 构造函数，初始化condition变量和typeHandler变量和noValue变量
        }
        // 获取值

        public Object getValue() {
            return value;
        // 获取第二个值
        }
        // 构造函数，初始化condition变量和value变量和typeHandler变量和singleValue变量

        public Object getSecondValue() {
            return secondValue;
        // 判断是否没有值
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        // 构造函数，初始化condition变量和value变量和singleValue变量
        }

        public boolean isBetweenValue() {
            return betweenValue;
        // 构造函数，初始化condition变量和value变量和secondValue变量和typeHandler变量和betweenValue变量
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }
        // 构造函数，初始化condition变量和value变量和secondValue变量和betweenValue变量

        // 构造函数，传入条件
        protected Criterion(String condition) {
            super();
            // 设置条件
            this.condition = condition;
            // 设置typeHandler为null
            this.typeHandler = null;
            // 设置noValue为true
            this.noValue = true;
        }

        // 构造函数，用于创建Criterion对象
        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            // 设置条件
            this.condition = condition;
            // 设置值
            this.value = value;
            // 设置类型处理器
            this.typeHandler = typeHandler;
            // 判断值是否为List类型
            if (value instanceof List<?>) {
                // 如果是List类型，则设置listValue为true
                this.listValue = true;
            } else {
                // 否则，设置singleValue为true
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
        // 构造函数，用于创建Criterion对象
            this(condition, value, null);
        }
            // 设置条件

            // 设置值
            // 设置第二个值
        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            // 设置类型处理器
            super();
            this.condition = condition;
            this.value = value;
            // 设置typeHandler
            this.secondValue = secondValue;
            // 设置betweenValue为true
            this.typeHandler = typeHandler;
        // 构造函数，传入条件、值、第二个值
            this.betweenValue = true;
            // 调用另一个构造函数，传入条件、值、第二个值和null
        }

        // 构造函数，传入条件、值、第二个值
        protected Criterion(String condition, Object value, Object secondValue) {
            // 调用另一个构造函数，传入条件、值、第二个值和null
            this(condition, value, secondValue, null);
        }
    }
}